;===============================================================================
;
;	boot.inc - Steel Cap Boot include file
;
;===============================================================================
;
;	Released as Public Domain Software.
;
;	No Warranties expressed or implied.
;
;===============================================================================
;
;	0.0.1		2010-05-27 (bz) first release
;
;===============================================================================

%ifndef __BOOT_INC
%define __BOOT_INC

%define	ORG(x) times (x)-($-$$) db 0

;	Boot sector offsets
%define BPB_END		0x003e		;FAT12/16 BPB end address
%define	BPB_NT_END	0x0054		;NT BPB end address
%define	BPB_FAT32_END	0x005a		;FAT32 BPB end address
%define EXTREAD_ADDR	0x0198		;BIOS extended read package
%define	LOADER_SECT	0x01a0		;boot loader sector
%define	PART_TBL	0x01be		;partition table
%define BOOT_SIG	0x01fe		;boot sector signature

;	FAT12/16 BIOS Parameter Block
struc	fat16
	.oemname	resb	8	;OEM name
	.sectsz		resw	1	;sector size in bytes
	.blksectcnt	resb	1	;sector count per block
	.ressectcnt	resw	1	;reserved sector count
	.fatcnt		resb	1	;number of File Allocation Tables
	.rootentcnt	resw	1	;number of root directory entries
	.sectcnt	resw	1	;number of sectors on volume
	.mediadesc	resb	1	;media descriptor id
	.fatsectcnt	resw	1	;sector count per FAT
	.trksectcnt	resw	1	;sector count per track
	.headcnt	resw	1	;number of disk heads
	.hidsectcnt	resd	1	;hidden sector count before volume
	.volsectcnt	resd	1	;number of sectors on volume
	.diskno		resb	1	;BIOS disk number
	.chkdskfl	resb	1	;check disk flag
	.bpbsig		resb	1	;BPB signature
	.volserial	resd	1	;volume serial number
	.vollabel	resb	11	;volume label
	.fstype		resb	8	;file system type
endstruc
FAT16_SIZE	equ	fat16_size

%endif
