;===============================================================================
;
;	scbtest.s - Steel Cap Boot Test
;
;	A simple test file loaded by the Steel Cap Boot loader to demostrate
;	its use.
;
;	Requirements:
;	The Steel Cap Boot loader.
;
;===============================================================================
;
;	Released as Public Domain Software.
;
;	No Warranties expressed or implied.
;
;===============================================================================
;
;	0.0.1		2010-05-27 (bz) first release
;
;===============================================================================

%include "boot.inc"

	section	.text
	bits	16		;start with 8086 code only

	global	_start	
_start:
	jmp	begin

	align	0x04
	;fixed address data should go here before the 0xaa55 signature	
loadmsg:	db	'scbtest is loaded at: ',0
divmsg:		db	':',0
diskmsg:	db	0ah,0dh,'From BIOS drive no: ',0
endmsg:		db	0ah,0dh,'This machine needs to be reset.',0
diskno:		db	-1

	ORG(BOOT_SIG)
	dw	0xaa55
	
begin:
	;set segment bases
	cli
	mov	ax,cs
	mov	ds,ax
	mov	es,ax

	;create stack 
	mov	ss,ax			
	mov	sp,0xffff
	sti
	
	mov	[diskno],dl
	mov	si,loadmsg
	call	print
	
	mov	ax,cs
	call	puthex
	
	mov	si,divmsg
	call	print

	mov	ax,_start
	call	puthex
	
	mov	si,diskmsg
	call	print

	xor	ax,ax
	mov	al,[diskno]
	call	puthex
	
	mov	si,endmsg
	call	print
	jmp	$
	
;	BIOS print
;
;entry:
;	DS:SI = string to print
;
_pc:
	mov	ah,0x0e
	mov	bx,0x0007
	int	0x10
print:
	lodsb
	cmp	al,0
	jnz	_pc
	ret

;	Print a 2 byte hex value
;
;entry:
;	AX = hex value
;
puthex:
	push	cx
	mov	cx,4
.loop1:
	rol	ax,4
	push	ax
	and	al,0x0f
	add	al,'0'
	cmp	al,'9'
	jbe	.1
	add	al,'A'-'9'-1
.1:
	call	putchar
	pop	ax
	loop	.loop1
	pop	cx
	ret
	
putchar:
	mov	bh,0x0001
	mov	ah,0x0e
	int	0x10	
	ret

